/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         ddlparse
#define yylex           ddllex
#define yyerror         ddlerror
#define yydebug         ddldebug
#define yynerrs         ddlnerrs


/* Copy the first part of user declarations.  */


#include "sqlparser.h"

#ifdef _MSC_VER
#include "ddl-gram-win.h"
#else
#include "ddl-gram.h"
#endif

#include "my_global.h"
#include "my_sys.h"

#define scanner x->scanner

using namespace std;
using namespace ddlpackage;	

int ddllex(YYSTYPE* ddllval, void* yyscanner);
void ddlerror(struct pass_to_bison* x, char const *s);
char* copy_string(const char *str);

void fix_column_length(SchemaObject* elem, const CHARSET_INFO* def_cs) {
    auto* column = dynamic_cast<ColumnDef*>(elem);
    if (column == NULL || column->fType == NULL)
    {
        return;
    }

    if (column->fType->fType == DDL_VARCHAR ||
         column->fType->fType == DDL_CHAR ||
         (column->fType->fType == DDL_TEXT && column->fType->fExplicitLength))
    {
        unsigned mul = def_cs ? def_cs->mbmaxlen : 1;
        if (column->fType->fCharset) {
            const CHARSET_INFO* cs = get_charset_by_csname(column->fType->fCharset, MY_CS_PRIMARY, MYF(0));
            if (cs)
                mul = cs->mbmaxlen;
        }
        column->fType->fLength *= mul;
    }

    if (column->fType->fType == DDL_TEXT && column->fType->fExplicitLength)
    {
        // Rounding the resulting length of TEXT(N) field to the next default length
        if (column->fType->fLength <= 255)
            column->fType->fLength = 255;
        else if (column->fType->fLength <= 65535)
            column->fType->fLength = 65535;
        else if (column->fType->fLength <= 16777215)
            column->fType->fLength = 16777215;
        else if (column->fType->fLength <= 2100000000)
            column->fType->fLength = 2100000000;
        // otherwise leave the decision to a caller code
    }
}




# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "ddl-gram.h".  */
#ifndef YY_DDL_HOME_BUILDBOT_AMD64_RHEL_7_RPM_AUTOBAKE_BUILD_PADDING_FOR_CPACK_RPM_BUILD_SOURCE_DIRS_PREFIX_STORAGE_COLUMNSTORE_COLUMNSTORE_DBCON_DDLPACKAGE_DDL_GRAM_H_INCLUDED
# define YY_DDL_HOME_BUILDBOT_AMD64_RHEL_7_RPM_AUTOBAKE_BUILD_PADDING_FOR_CPACK_RPM_BUILD_SOURCE_DIRS_PREFIX_STORAGE_COLUMNSTORE_COLUMNSTORE_DBCON_DDLPACKAGE_DDL_GRAM_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int ddldebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    ACTION = 258,
    ADD = 259,
    ALTER = 260,
    AUTO_INCREMENT = 261,
    BIGINT = 262,
    BIT = 263,
    BLOB = 264,
    IDB_BLOB = 265,
    CASCADE = 266,
    IDB_CHAR = 267,
    CHARACTER = 268,
    CHECK = 269,
    CLOB = 270,
    COLUMN = 271,
    COLUMNS = 272,
    COMMENT = 273,
    CONSTRAINT = 274,
    CONSTRAINTS = 275,
    CREATE = 276,
    CURRENT_USER = 277,
    DATETIME = 278,
    DEC = 279,
    DECIMAL = 280,
    DEFAULT = 281,
    DEFERRABLE = 282,
    DEFERRED = 283,
    IDB_DELETE = 284,
    DROP = 285,
    ENGINE = 286,
    FOREIGN = 287,
    FULL = 288,
    IMMEDIATE = 289,
    INDEX = 290,
    INITIALLY = 291,
    IDB_INT = 292,
    INTEGER = 293,
    KEY = 294,
    LONGBLOB = 295,
    LONGTEXT = 296,
    MATCH = 297,
    MAX_ROWS = 298,
    MEDIUMBLOB = 299,
    MEDIUMTEXT = 300,
    MIN_ROWS = 301,
    MODIFY = 302,
    NO = 303,
    NOT = 304,
    NULL_TOK = 305,
    NUMBER = 306,
    NUMERIC = 307,
    ON = 308,
    PARTIAL = 309,
    PRECISION = 310,
    PRIMARY = 311,
    REFERENCES = 312,
    RENAME = 313,
    RESTRICT = 314,
    SET = 315,
    SMALLINT = 316,
    TABLE = 317,
    TEXT = 318,
    TINYBLOB = 319,
    TINYTEXT = 320,
    TINYINT = 321,
    TO = 322,
    UNIQUE = 323,
    UNSIGNED = 324,
    UPDATE = 325,
    USER = 326,
    SESSION_USER = 327,
    SYSTEM_USER = 328,
    VARCHAR = 329,
    VARBINARY = 330,
    VARYING = 331,
    WITH = 332,
    ZONE = 333,
    DOUBLE = 334,
    IDB_FLOAT = 335,
    REAL = 336,
    CHARSET = 337,
    COLLATE = 338,
    IDB_IF = 339,
    EXISTS = 340,
    CHANGE = 341,
    TRUNCATE = 342,
    BOOL = 343,
    BOOLEAN = 344,
    MEDIUMINT = 345,
    TIMESTAMP = 346,
    DQ_IDENT = 347,
    IDENT = 348,
    FCONST = 349,
    SCONST = 350,
    CP_SEARCH_CONDITION_TEXT = 351,
    ICONST = 352,
    DATE = 353,
    TIME = 354
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{


  ddlpackage::AlterTableStatement *alterTableStmt;
  ddlpackage::AlterTableAction *ata;
  ddlpackage::AlterTableActionList *ataList;
  ddlpackage::DDL_CONSTRAINT_ATTRIBUTES cattr;
  std::pair<std::string, std::string> *tableOption;
  const char *columnOption;
  ddlpackage::ColumnConstraintDef *columnConstraintDef;
  ddlpackage::ColumnNameList *columnNameList;
  ddlpackage::ColumnType* columnType;
  ddlpackage::ConstraintAttributes *constraintAttributes;
  ddlpackage::ColumnConstraintList *constraintList;
  ddlpackage::DDL_CONSTRAINTS constraintType;
  double dval;
  bool flag;
  int ival;
  ddlpackage::QualifiedName *qualifiedName;
  ddlpackage::SchemaObject *schemaObject;
  ddlpackage::SqlStatement *sqlStmt;
  ddlpackage::SqlStatementList *sqlStmtList;
  const char *str;
  ddlpackage::TableConstraintDef *tableConstraint;
  ddlpackage::TableElementList *tableElementList;
  ddlpackage::TableOptionMap *tableOptionMap;
  ddlpackage::ColumnDefaultValue *colDefault;
  ddlpackage::DDL_MATCH_TYPE matchType;
  ddlpackage::DDL_REFERENTIAL_ACTION refActionCode;
  ddlpackage::ReferentialAction *refAction;


};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif



int ddlparse (struct ddlpackage::pass_to_bison * x);

#endif /* !YY_DDL_HOME_BUILDBOT_AMD64_RHEL_7_RPM_AUTOBAKE_BUILD_PADDING_FOR_CPACK_RPM_BUILD_SOURCE_DIRS_PREFIX_STORAGE_COLUMNSTORE_COLUMNSTORE_DBCON_DDLPACKAGE_DDL_GRAM_H_INCLUDED  */

/* Copy the second part of user declarations.  */






#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  28
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   484

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  107
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  85
/* YYNRULES -- Number of rules.  */
#define YYNRULES  266
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  456

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   354

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,   106,
     101,   102,     2,     2,   103,     2,   105,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,   100,
       2,   104,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   244,   244,   249,   259,   274,   275,   276,   277,   278,
     279,   280,   281,   285,   286,   293,   294,   298,   304,   309,
     317,   318,   322,   333,   334,   338,   339,   343,   353,   359,
     367,   368,   372,   378,   386,   387,   391,   392,   393,   397,
     407,   412,   420,   421,   425,   432,   433,   437,   441,   442,
     446,   447,   451,   457,   466,   467,   471,   472,   476,   480,
     484,   485,   486,   487,   488,   492,   498,   507,   507,   511,
     513,   515,   517,   519,   521,   526,   528,   530,   532,   534,
     538,   545,   557,   562,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   582,   585,   592,   595,   601,   603,   605,
     607,   609,   611,   613,   615,   617,   619,   621,   623,   625,
     627,   629,   631,   633,   635,   637,   639,   644,   651,   655,
     656,   660,   664,   670,   677,   678,   685,   686,   687,   693,
     702,   703,   704,   708,   712,   715,   719,   723,   727,   731,
     735,   739,   743,   747,   751,   757,   760,   764,   768,   772,
     773,   774,   775,   776,   780,   781,   785,   787,   791,   793,
     797,   801,   802,   803,   804,   805,   809,   814,   823,   828,
     836,   847,   862,   863,   867,   872,   886,   887,   891,   902,
     903,   907,   908,   909,   910,   911,   915,   919,   923,   925,
     929,   934,   939,   944,   949,   955,   961,   969,   977,   982,
     987,   992,   997,  1005,  1011,  1016,  1021,  1026,  1034,  1035,
    1039,  1045,  1051,  1057,  1063,  1069,  1075,  1080,  1085,  1090,
    1095,  1100,  1105,  1110,  1115,  1120,  1125,  1131,  1137,  1142,
    1150,  1151,  1152,  1156,  1157,  1161,  1166,  1171,  1176,  1181,
    1186,  1191,  1196,  1204,  1206,  1207,  1211,  1212,  1213,  1217,
    1224,  1230,  1237,  1245,  1246,  1250,  1251,  1252,  1253,  1254,
    1258,  1259,  1260,  1264,  1265,  1269,  1270
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ACTION", "ADD", "ALTER",
  "AUTO_INCREMENT", "BIGINT", "BIT", "BLOB", "IDB_BLOB", "CASCADE",
  "IDB_CHAR", "CHARACTER", "CHECK", "CLOB", "COLUMN", "COLUMNS", "COMMENT",
  "CONSTRAINT", "CONSTRAINTS", "CREATE", "CURRENT_USER", "DATETIME", "DEC",
  "DECIMAL", "DEFAULT", "DEFERRABLE", "DEFERRED", "IDB_DELETE", "DROP",
  "ENGINE", "FOREIGN", "FULL", "IMMEDIATE", "INDEX", "INITIALLY",
  "IDB_INT", "INTEGER", "KEY", "LONGBLOB", "LONGTEXT", "MATCH", "MAX_ROWS",
  "MEDIUMBLOB", "MEDIUMTEXT", "MIN_ROWS", "MODIFY", "NO", "NOT",
  "NULL_TOK", "NUMBER", "NUMERIC", "ON", "PARTIAL", "PRECISION", "PRIMARY",
  "REFERENCES", "RENAME", "RESTRICT", "SET", "SMALLINT", "TABLE", "TEXT",
  "TINYBLOB", "TINYTEXT", "TINYINT", "TO", "UNIQUE", "UNSIGNED", "UPDATE",
  "USER", "SESSION_USER", "SYSTEM_USER", "VARCHAR", "VARBINARY", "VARYING",
  "WITH", "ZONE", "DOUBLE", "IDB_FLOAT", "REAL", "CHARSET", "COLLATE",
  "IDB_IF", "EXISTS", "CHANGE", "TRUNCATE", "BOOL", "BOOLEAN", "MEDIUMINT",
  "TIMESTAMP", "DQ_IDENT", "IDENT", "FCONST", "SCONST",
  "CP_SEARCH_CONDITION_TEXT", "ICONST", "DATE", "TIME", "';'", "'('",
  "')'", "','", "'='", "'.'", "'\\''", "$accept", "stmtblock", "stmtmulti",
  "stmt", "drop_table_statement", "opt_if_exists", "drop_index_statement",
  "create_index_statement", "opt_table_options", "create_table_statement",
  "opt_if_not_exists", "trunc_table_statement", "rename_table_statement",
  "table_element_list", "table_element", "table_constraint_def",
  "opt_constraint_name", "table_constraint", "unique_constraint_def",
  "column_name_list", "unique_specifier", "referential_constraint_def",
  "opt_match_type", "match_type", "opt_referential_triggered_action",
  "referential_triggered_action", "opt_delete_rule", "opt_update_rule",
  "update_rule", "delete_rule", "referential_action", "table_options",
  "opt_equal", "table_option", "alter_table_statement",
  "alter_table_actions", "alter_table_action", "alter_table_comment",
  "modify_column", "rename_column", "drop_table_constraint_def",
  "add_table_constraint_def", "ata_rename_table", "table_name",
  "qualified_name", "ident", "ata_add_column", "column_name",
  "constraint_name", "column_option", "column_def", "opt_null_tok",
  "default_clause", "optional_braces", "opt_column_charset",
  "opt_column_collate", "data_type", "column_qualifier_list",
  "column_constraint_def", "opt_constraint_attributes",
  "constraint_attributes", "opt_deferrability_clause",
  "deferrability_clause", "constraint_check_time", "column_constraint",
  "check_constraint_def", "string_literal", "opt_quoted_literal",
  "character_string_type", "binary_string_type", "blob_type", "text_type",
  "numeric_type", "exact_numeric_type", "opt_precision_scale",
  "opt_display_width", "approximate_numeric_type",
  "opt_display_precision_scale_null", "literal", "datetime_type",
  "opt_time_precision", "drop_column_def", "drop_behavior",
  "alter_column_def", "opt_column", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
      59,    40,    41,    44,    61,    46,    39
};
# endif

#define YYPACT_NINF -298

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-298)))

#define YYTABLE_NINF -134

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     255,   -25,    -1,    -4,   -20,    96,    53,   -14,  -298,  -298,
    -298,  -298,  -298,  -298,  -298,  -298,    62,    62,    30,   111,
      62,    98,    62,    62,  -298,  -298,  -298,   109,  -298,   255,
     249,  -298,   139,   178,    62,    62,  -298,   146,    62,   171,
    -298,    62,  -298,   207,   226,    99,   196,    36,    71,    87,
      95,  -298,  -298,  -298,  -298,  -298,  -298,  -298,  -298,  -298,
    -298,    62,   161,   150,   204,  -298,   266,    62,  -298,   217,
      62,  -298,  -298,   141,  -298,   176,   297,   184,  -298,  -298,
    -298,   163,  -298,   189,   165,  -298,   268,   186,    62,   163,
    -298,    46,   163,   184,    62,  -298,   163,   163,   249,  -298,
     203,  -298,   141,    62,   292,  -298,   141,  -298,   176,  -298,
      75,  -298,  -298,  -298,   219,   284,   302,  -298,    14,  -298,
     242,  -298,  -298,   254,   275,  -298,   -41,    64,  -298,   285,
     291,   254,   254,  -298,  -298,  -298,  -298,   291,   291,   254,
     295,  -298,  -298,   254,   296,   298,   -29,   301,   301,  -298,
    -298,   254,   285,  -298,   285,   300,   345,  -298,  -298,   345,
    -298,  -298,  -298,  -298,    92,   264,  -298,   163,    46,   163,
      46,   117,  -298,  -298,  -298,  -298,   184,  -298,  -298,   163,
     184,  -298,   163,   167,   303,  -298,   229,    14,  -298,   141,
     307,   304,  -298,   337,    20,  -298,  -298,   366,   163,   309,
     329,   310,   311,   312,   313,   314,   316,  -298,   320,   341,
     347,   349,   350,   351,   352,   325,   354,   327,   328,   301,
     330,   357,   359,   360,   361,  -298,  -298,  -298,   272,   371,
     353,   353,   406,   407,  -298,   244,  -298,   246,  -298,  -298,
     163,  -298,   184,   272,   256,   308,   163,  -298,  -298,  -298,
     332,   163,  -298,  -298,  -298,  -298,  -298,  -298,   260,   333,
    -298,   335,   342,   336,   343,   339,   340,   269,  -298,  -298,
    -298,  -298,  -298,  -298,   344,  -298,   346,   348,   374,   277,
    -298,  -298,  -298,  -298,  -298,   165,    62,   230,   394,   408,
    -298,  -298,   319,   272,  -298,    14,  -298,   124,   124,  -298,
    -298,  -298,  -298,  -298,  -298,  -298,   272,  -298,   319,   272,
     308,   355,    99,    33,   355,   355,   355,   355,   355,  -298,
     308,  -298,   279,  -298,   281,  -298,  -298,  -298,   356,  -298,
     358,  -298,  -298,  -298,   364,  -298,  -298,  -298,  -298,  -298,
     365,  -298,   127,   362,  -298,  -298,  -298,  -298,  -298,  -298,
    -298,  -298,  -298,  -298,  -298,  -298,   319,  -298,   427,  -298,
    -298,  -298,  -298,  -298,  -298,  -298,   319,   272,  -298,   319,
    -298,   427,  -298,   367,   165,  -298,   389,   355,   355,    62,
     368,   369,    62,   124,  -298,   308,   395,  -298,  -298,   370,
     372,    14,   373,  -298,  -298,  -298,  -298,   319,  -298,   427,
    -298,  -298,  -298,  -298,   355,    62,   124,  -298,  -298,  -298,
    -298,  -298,  -298,    62,  -298,  -298,  -298,  -298,  -298,  -298,
      62,  -298,  -298,   375,  -298,   163,   286,   133,  -298,   133,
    -298,   398,  -298,  -298,     3,  -298,  -298,   400,   401,    60,
      60,   426,  -298,  -298,   386,  -298,  -298,  -298,   454,  -298,
      67,  -298,  -298,  -298,  -298,  -298
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
      12,     0,     0,     0,     0,     0,     0,     2,     4,     8,
       7,     9,     6,    10,    11,     5,     0,     0,    24,     0,
       0,    16,     0,     0,   124,   125,    26,   122,     1,    12,
       0,   121,     0,     0,     0,     0,    17,     0,     0,     0,
      25,     0,     3,    35,   266,     0,     0,     0,     0,     0,
      80,    81,    92,    90,    91,    88,    87,    89,    84,    85,
      86,     0,     0,     0,     0,    15,    13,     0,   123,     0,
      35,   131,   130,    35,   118,     0,   132,     0,    34,   126,
     265,     0,    68,     0,     0,    94,     0,     0,     0,     0,
     132,   262,     0,     0,     0,   119,     0,     0,     0,    83,
       0,    23,    35,     0,     0,    27,    35,   127,     0,   133,
       0,    28,    31,    30,     0,     0,     0,    43,   173,    36,
       0,    37,    38,   234,   199,   166,   191,   190,   167,   254,
     232,   234,   234,   202,   207,   201,   206,   232,   232,   234,
     204,   200,   205,   234,     0,     0,   245,   245,   245,   227,
     226,   234,   254,   250,   254,   145,   156,   161,   164,   156,
     162,   208,   209,   163,     0,     0,    93,     0,   262,     0,
     262,     0,    40,   260,   261,   255,     0,    95,   120,     0,
       0,    82,     0,     0,     0,    14,     0,   173,   128,    35,
       0,     0,    42,     0,     0,    33,   172,   177,     0,     0,
     220,     0,     0,     0,     0,     0,     0,   249,     0,   212,
     217,   216,   214,   210,   218,     0,   219,     0,     0,   245,
       0,   235,   241,   239,   228,   252,   251,   146,   135,     0,
     158,   158,     0,     0,   187,     0,   256,     0,   117,   258,
       0,    96,     0,    97,     0,    21,     0,   129,    32,    29,
       0,     0,   175,   179,   180,   178,   174,   176,     0,     0,
     225,     0,     0,     0,     0,     0,     0,     0,   213,   222,
     221,   215,   211,   223,     0,   224,     0,     0,   237,     0,
     236,   242,   240,   229,   184,     0,     0,     0,     0,     0,
     182,   139,   138,   136,   168,   173,   185,     0,     0,   160,
     165,   264,   263,   257,   259,    41,    99,    98,   105,   101,
      21,    67,     0,     0,    67,    67,    67,    67,    67,    22,
      20,    65,     0,   186,     0,    39,   233,   198,     0,   193,
       0,   192,   253,   230,     0,   203,   196,   197,   238,   243,
       0,   134,     0,   154,   149,   150,   152,   153,   148,   248,
     246,   247,   147,   181,   183,   144,   137,   140,   142,   169,
     170,   189,   188,   157,   159,   100,   106,   102,   107,   111,
     103,   109,    18,     0,     0,    73,     0,    67,    67,     0,
       0,     0,     0,     0,    66,    21,     0,   195,   194,     0,
       0,   173,     0,   151,   141,   143,   108,   112,   104,   110,
     115,   113,    74,    72,    67,     0,     0,    69,    70,    71,
      76,    79,    19,     0,   231,   244,   171,   155,   116,   114,
       0,    75,    78,     0,    77,     0,     0,    46,    48,     0,
      49,    51,    45,    47,     0,    44,    50,    55,    57,     0,
       0,     0,    52,    54,     0,    53,    56,    60,     0,    64,
       0,    59,    58,    63,    62,    61
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -298,  -298,  -298,   438,  -298,  -298,  -298,  -298,  -297,  -298,
    -298,  -298,  -298,    25,   280,   425,   403,   363,  -298,  -159,
    -298,  -298,  -298,    41,  -298,  -298,  -298,  -298,    39,    42,
      38,  -298,  -167,   160,  -298,  -298,    28,  -298,  -298,  -298,
    -298,  -298,  -298,   -28,   101,    -5,  -298,   -22,   -85,  -197,
      12,  -298,  -224,  -298,   322,   251,   -86,  -229,  -265,  -185,
    -298,  -298,  -298,   290,   142,   -59,   -44,  -276,  -298,  -298,
    -298,  -298,  -298,  -298,   257,   213,  -298,  -143,  -298,  -298,
      19,  -298,   149,  -298,  -298
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     6,     7,     8,     9,    38,    10,    11,   319,    12,
      34,    13,    14,   110,   111,   112,    75,   118,   119,   171,
     120,   121,   431,   432,   435,   436,   442,   445,   437,   438,
     451,   320,    84,   321,    15,    50,    51,    52,    53,    54,
      55,    56,    57,    30,    31,    90,    58,   172,    78,   291,
     113,   228,   292,   393,   230,   299,   155,   293,   294,   195,
     196,   256,   257,   197,   295,   296,   362,   363,   156,   157,
     158,   159,   160,   161,   209,   200,   162,   221,   352,   163,
     207,    59,   175,    60,    81
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      27,    85,   248,   170,   222,   223,    63,   177,   235,   302,
     237,    27,    27,   372,   309,    27,   122,    27,    27,   308,
      95,    77,   364,   244,    91,    93,   219,    97,   359,    27,
      27,    20,   439,    27,    17,   202,    68,    16,    76,   258,
     166,   193,    22,    27,   359,   376,   307,    77,   253,   122,
     194,    77,    92,    28,   254,    79,    27,   173,    21,   164,
     203,    18,    27,   356,   168,   109,   178,    19,    76,   358,
     176,   447,   220,   440,   179,   180,   278,   367,    99,   369,
      77,   107,   366,   109,    77,   371,    29,   322,   412,    27,
     241,   359,   324,   454,   243,   355,   357,    76,    27,    43,
      44,    76,   359,    96,   359,   174,    26,   411,   448,   365,
     360,   368,   370,    45,    33,   377,   378,   455,    32,   449,
     450,    36,   232,    39,    40,    46,   181,   183,    24,    25,
     422,   186,   359,   284,    71,    72,    64,   397,    94,    66,
     204,   114,    47,   399,   373,   374,    35,   379,   380,   381,
     382,   383,   233,    48,    24,    25,   306,   242,    23,   394,
      70,   395,   100,    24,    25,   205,   428,    77,   105,   396,
     398,   225,   400,   226,   401,   429,   288,   188,   189,    24,
      25,    49,    37,   289,    76,    71,    72,   430,    24,    25,
     114,   123,    61,   124,   125,   290,   126,   127,    98,   128,
     418,   342,   419,    82,   184,    83,   416,   129,   115,   130,
     405,   406,    86,    87,    41,    88,    24,    25,   305,   239,
     240,   131,   132,    69,   133,   134,    70,    62,   135,   136,
      83,    65,   116,    24,    25,   137,   138,   420,    67,    71,
      72,   341,    80,   351,   117,   139,   101,   140,   141,   142,
     143,   102,   343,    43,    44,    24,    25,   103,   144,   145,
       1,    71,    72,   146,   147,   148,   426,    45,   375,   245,
     189,    83,   149,   150,   151,   152,     2,   104,   284,    46,
     344,   109,   153,   154,   165,     3,   114,   169,    24,    25,
     285,   286,   361,   361,    71,    72,    47,    89,   287,    24,
      25,   345,   346,   347,   182,    71,    72,    48,    73,    24,
      25,  -133,   185,     4,   311,    71,    72,   236,   106,   238,
     190,   288,   348,   191,   349,   284,   312,   350,   289,  -133,
     403,   247,   189,   114,   313,    49,    83,   285,   286,   314,
     290,   192,     5,   198,   210,   211,   303,   240,   304,   240,
     227,   315,   214,  -133,   316,   199,   216,   229,   310,   240,
      24,    25,   325,   240,   224,  -133,    71,    72,   288,   167,
     234,   333,   334,   194,   407,   289,   201,   410,   361,   339,
     340,   385,   240,   386,   240,   423,   206,   290,   427,   240,
     317,   318,   208,   255,   212,   213,   215,   217,   260,   218,
     421,   361,   220,   250,   246,   251,   259,   261,    27,   263,
     268,   265,   262,   266,   264,   424,   269,   267,   270,   271,
     272,   273,   274,   275,   276,   277,   280,   279,   281,   282,
     283,   297,   301,   287,   323,   326,   298,   327,   329,   328,
     330,   331,   332,   338,   353,   285,   335,   354,   336,   404,
     337,   434,   413,   441,   444,   439,   440,   453,   387,    82,
     388,   389,   390,   392,   402,   408,   409,    42,    74,   249,
     433,   187,   414,   108,   415,   417,   425,   446,   452,   443,
     384,   231,   300,   252,   391
};

static const yytype_uint16 yycheck[] =
{
       5,    45,   187,    88,   147,   148,    34,    93,   167,   233,
     169,    16,    17,   310,   243,    20,    75,    22,    23,   243,
      48,    43,   298,   182,    46,    47,    55,    49,   293,    34,
      35,    35,    29,    38,    35,    76,    41,    62,    43,   198,
      84,    27,    62,    48,   309,    12,   243,    69,    28,   108,
      36,    73,    16,     0,    34,    43,    61,    11,    62,    81,
     101,    62,    67,   292,    86,    70,    94,    68,    73,   293,
      92,    11,   101,    70,    96,    97,   219,   306,    50,   308,
     102,    69,   306,    88,   106,   309,   100,   246,   385,    94,
     176,   356,   251,    26,   180,   292,   293,   102,   103,     4,
       5,   106,   367,    16,   369,    59,     5,   383,    48,   306,
     295,   308,   309,    18,    84,    82,    83,    50,    17,    59,
      60,    20,    30,    22,    23,    30,    98,   102,    92,    93,
     406,   106,   397,     6,    98,    99,    35,   366,    67,    38,
      76,    14,    47,   367,   311,   312,    35,   314,   315,   316,
     317,   318,    60,    58,    92,    93,   242,   179,    62,   356,
      19,   358,    61,    92,    93,   101,    33,   189,    67,   366,
     367,   152,   369,   154,   371,    42,    49,   102,   103,    92,
      93,    86,    84,    56,   189,    98,    99,    54,    92,    93,
      14,     7,    53,     9,    10,    68,    12,    13,   103,    15,
     397,   286,   399,   104,   103,   106,   391,    23,    32,    25,
     377,   378,    16,    17,   105,    19,    92,    93,   240,   102,
     103,    37,    38,    16,    40,    41,    19,    49,    44,    45,
     106,    85,    56,    92,    93,    51,    52,   404,    67,    98,
      99,   285,    16,   287,    68,    61,    85,    63,    64,    65,
      66,   101,    22,     4,     5,    92,    93,    53,    74,    75,
       5,    98,    99,    79,    80,    81,   425,    18,   312,   102,
     103,   106,    88,    89,    90,    91,    21,    11,     6,    30,
      50,   286,    98,    99,    95,    30,    14,   101,    92,    93,
      18,    19,   297,   298,    98,    99,    47,   101,    26,    92,
      93,    71,    72,    73,   101,    98,    99,    58,   101,    92,
      93,    14,    20,    58,     6,    98,    99,   168,   101,   170,
     101,    49,    92,    39,    94,     6,    18,    97,    56,    32,
     374,   102,   103,    14,    26,    86,   106,    18,    19,    31,
      68,    39,    87,   101,   131,   132,   102,   103,   102,   103,
      50,    43,   139,    56,    46,   101,   143,    12,   102,   103,
      92,    93,   102,   103,   151,    68,    98,    99,    49,   101,
     106,   102,   103,    36,   379,    56,   101,   382,   383,   102,
     103,   102,   103,   102,   103,   413,   101,    68,   102,   103,
      82,    83,   101,    27,   137,   138,   101,   101,    69,   101,
     405,   406,   101,    96,   101,   101,    97,    97,   413,    97,
      69,    97,   101,    97,   101,   420,    69,    97,    69,    69,
      69,    69,    97,    69,    97,    97,    69,    97,    69,    69,
      69,    60,    26,    26,   102,   102,    83,   102,   102,    97,
      97,   102,   102,    69,    50,    18,   102,    39,   102,    60,
     102,    53,    57,    53,    53,    29,    70,     3,   102,   104,
     102,    97,    97,   101,    97,    97,    97,    29,    43,   189,
     429,   108,   102,    70,   102,   102,   101,   438,   440,   437,
     320,   159,   231,   193,   342
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     5,    21,    30,    58,    87,   108,   109,   110,   111,
     113,   114,   116,   118,   119,   141,    62,    35,    62,    68,
      35,    62,    62,    62,    92,    93,   151,   152,     0,   100,
     150,   151,   151,    84,   117,    35,   151,    84,   112,   151,
     151,   105,   110,     4,     5,    18,    30,    47,    58,    86,
     142,   143,   144,   145,   146,   147,   148,   149,   153,   188,
     190,    53,    49,   150,   151,    85,   151,    67,   152,    16,
      19,    98,    99,   101,   122,   123,   152,   154,   155,   157,
      16,   191,   104,   106,   139,   173,    16,    17,    19,   101,
     152,   154,    16,   154,    67,   150,    16,   154,   103,   143,
     151,    85,   101,    53,    11,   151,   101,   157,   123,   152,
     120,   121,   122,   157,    14,    32,    56,    68,   124,   125,
     127,   128,   172,     7,     9,    10,    12,    13,    15,    23,
      25,    37,    38,    40,    41,    44,    45,    51,    52,    61,
      63,    64,    65,    66,    74,    75,    79,    80,    81,    88,
      89,    90,    91,    98,    99,   163,   175,   176,   177,   178,
     179,   180,   183,   186,   154,    95,   173,   101,   154,   101,
     155,   126,   154,    11,    59,   189,   154,   163,   150,   154,
     154,   143,   101,   120,   151,    20,   120,   124,   102,   103,
     101,    39,    39,    27,    36,   166,   167,   170,   101,   101,
     182,   101,    76,   101,    76,   101,   101,   187,   101,   181,
     182,   182,   181,   181,   182,   101,   182,   101,   101,    55,
     101,   184,   184,   184,   182,   187,   187,    50,   158,    12,
     161,   161,    30,    60,   106,   126,   189,   126,   189,   102,
     103,   163,   154,   163,   126,   102,   101,   102,   166,   121,
      96,   101,   170,    28,    34,    27,   168,   169,   126,    97,
      69,    97,   101,    97,   101,    97,    97,    97,    69,    69,
      69,    69,    69,    69,    97,    69,    97,    97,   184,    97,
      69,    69,    69,    69,     6,    18,    19,    26,    49,    56,
      68,   156,   159,   164,   165,   171,   172,    60,    83,   162,
     162,    26,   159,   102,   102,   154,   163,   156,   159,   164,
     102,     6,    18,    26,    31,    43,    46,    82,    83,   115,
     138,   140,   126,   102,   126,   102,   102,   102,    97,   102,
      97,   102,   102,   102,   103,   102,   102,   102,    69,   102,
     103,   173,   155,    22,    50,    71,    72,    73,    92,    94,
      97,   173,   185,    50,    39,   156,   164,   156,   159,   165,
     166,   152,   173,   174,   174,   156,   159,   164,   156,   164,
     156,   159,   115,   139,   139,   173,    12,    82,    83,   139,
     139,   139,   139,   139,   140,   102,   102,   102,   102,    97,
      97,   171,   101,   160,   156,   156,   156,   164,   156,   159,
     156,   156,    97,   173,    60,   139,   139,   152,    97,    97,
     152,   174,   115,    57,   102,   102,   166,   102,   156,   156,
     139,   152,   174,   150,   152,   101,   126,   102,    33,    42,
      54,   129,   130,   130,    53,   131,   132,   135,   136,    29,
      70,    53,   133,   136,    53,   134,   135,    11,    48,    59,
      60,   137,   137,     3,    26,    50
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   107,   108,   109,   109,   110,   110,   110,   110,   110,
     110,   110,   110,   111,   111,   112,   112,   113,   114,   114,
     115,   115,   116,   117,   117,   118,   118,   119,   120,   120,
     121,   121,   122,   122,   123,   123,   124,   124,   124,   125,
     126,   126,   127,   127,   128,   129,   129,   130,   130,   130,
     131,   131,   132,   132,   133,   133,   134,   134,   135,   136,
     137,   137,   137,   137,   137,   138,   138,   139,   139,   140,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
     141,   142,   142,   142,   143,   143,   143,   143,   143,   143,
     143,   143,   143,   144,   144,   145,   145,   146,   146,   146,
     146,   146,   146,   146,   146,   146,   146,   146,   146,   146,
     146,   146,   146,   146,   146,   146,   146,   147,   148,   149,
     149,   150,   151,   151,   152,   152,   153,   153,   153,   153,
     154,   154,   154,   155,   156,   157,   157,   157,   157,   157,
     157,   157,   157,   157,   157,   158,   158,   159,   159,   159,
     159,   159,   159,   159,   160,   160,   161,   161,   162,   162,
     163,   163,   163,   163,   163,   163,   163,   163,   164,   164,
     165,   165,   166,   166,   167,   167,   168,   168,   169,   170,
     170,   171,   171,   171,   171,   171,   172,   173,   174,   174,
     175,   175,   175,   175,   175,   175,   175,   176,   177,   177,
     177,   177,   177,   178,   178,   178,   178,   178,   179,   179,
     180,   180,   180,   180,   180,   180,   180,   180,   180,   180,
     180,   180,   180,   180,   180,   180,   180,   180,   180,   180,
     181,   181,   181,   182,   182,   183,   183,   183,   183,   183,
     183,   183,   183,   184,   184,   184,   185,   185,   185,   186,
     186,   186,   186,   187,   187,   188,   188,   188,   188,   188,
     189,   189,   189,   190,   190,   191,   191
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     4,     6,     2,     0,     3,     9,    10,
       1,     0,     8,     3,     0,     3,     2,     5,     1,     3,
       1,     1,     4,     3,     1,     0,     1,     1,     1,     4,
       1,     3,     2,     1,    12,     1,     0,     2,     1,     1,
       1,     0,     2,     2,     1,     0,     1,     0,     3,     3,
       1,     2,     2,     2,     1,     1,     2,     0,     1,     3,
       3,     3,     3,     2,     3,     4,     3,     5,     4,     3,
       4,     1,     3,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     2,     3,     4,     4,     5,     5,
       6,     5,     6,     6,     7,     5,     6,     6,     7,     6,
       7,     6,     7,     7,     8,     7,     8,     4,     2,     2,
       3,     1,     1,     3,     1,     1,     2,     3,     4,     5,
       1,     1,     1,     1,     2,     3,     4,     5,     4,     4,
       5,     6,     5,     6,     5,     0,     1,     2,     2,     2,
       2,     3,     2,     2,     0,     2,     0,     3,     0,     2,
       3,     1,     1,     1,     1,     3,     1,     1,     1,     2,
       2,     4,     1,     0,     2,     2,     1,     0,     1,     2,
       2,     2,     1,     2,     1,     1,     4,     3,     1,     1,
       1,     1,     4,     4,     5,     5,     4,     4,     4,     1,
       1,     1,     1,     4,     1,     1,     1,     1,     1,     1,
       2,     3,     2,     3,     2,     3,     2,     2,     2,     2,
       2,     3,     3,     3,     3,     3,     1,     1,     2,     3,
       3,     5,     0,     3,     0,     2,     3,     3,     4,     2,
       3,     2,     3,     3,     5,     0,     1,     1,     1,     2,
       1,     2,     2,     3,     0,     3,     4,     5,     4,     5,
       1,     1,     0,     5,     5,     1,     0
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (x, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, x); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, struct ddlpackage::pass_to_bison * x)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (x);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, struct ddlpackage::pass_to_bison * x)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, x);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule, struct ddlpackage::pass_to_bison * x)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              , x);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, x); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, struct ddlpackage::pass_to_bison * x)
{
  YYUSE (yyvaluep);
  YYUSE (x);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (struct ddlpackage::pass_to_bison * x)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, scanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

    { x->fParseTree = (yyvsp[0].sqlStmtList); }

    break;

  case 3:

    {
		if ((yyvsp[0].sqlStmt) != NULL) {
			(yyvsp[-2].sqlStmtList)->push_back((yyvsp[0].sqlStmt));
			(yyval.sqlStmtList) = (yyvsp[-2].sqlStmtList);
		}
		else {
			(yyval.sqlStmtList) = (yyvsp[-2].sqlStmtList);
		}
	}

    break;

  case 4:

    { 
		if ((yyvsp[0].sqlStmt) != NULL)
		{
			(yyval.sqlStmtList) = x->fParseTree;
			(yyval.sqlStmtList)->push_back((yyvsp[0].sqlStmt));
		}
		else
		{
			(yyval.sqlStmtList) = NULL;
		}
	}

    break;

  case 12:

    { (yyval.sqlStmt) = NULL; }

    break;

  case 13:

    {(yyval.sqlStmt) = new DropTableStatement((yyvsp[0].qualifiedName), false);}

    break;

  case 14:

    {
		{(yyval.sqlStmt) = new DropTableStatement((yyvsp[-2].qualifiedName), true);}
	}

    break;

  case 15:

    {(yyval.str) = NULL;}

    break;

  case 16:

    {(yyval.str) = NULL;}

    break;

  case 17:

    {(yyval.sqlStmt) = new DropIndexStatement((yyvsp[0].qualifiedName));}

    break;

  case 18:

    {
		(yyval.sqlStmt) = new CreateIndexStatement((yyvsp[-6].qualifiedName), (yyvsp[-4].qualifiedName), (yyvsp[-2].columnNameList), false);
		delete (yyvsp[0].tableOptionMap);
	}

    break;

  case 19:

    {
		(yyval.sqlStmt) = new CreateIndexStatement((yyvsp[-6].qualifiedName), (yyvsp[-4].qualifiedName), (yyvsp[-2].columnNameList), true);
		delete (yyvsp[0].tableOptionMap);
	}

    break;

  case 21:

    {(yyval.tableOptionMap) = NULL;}

    break;

  case 22:

    {
        for (auto* elem : *(yyvsp[-2].tableElementList))
        {
            fix_column_length(elem, x->default_table_charset);
        }
		(yyval.sqlStmt) = new CreateTableStatement(new TableDef((yyvsp[-4].qualifiedName), (yyvsp[-2].tableElementList), (yyvsp[0].tableOptionMap)));
	}

    break;

  case 23:

    {(yyval.str) = NULL;}

    break;

  case 24:

    {(yyval.str) = NULL;}

    break;

  case 25:

    {(yyval.sqlStmt) = new TruncTableStatement((yyvsp[0].qualifiedName));}

    break;

  case 26:

    { {(yyval.sqlStmt) = new TruncTableStatement((yyvsp[0].qualifiedName));} }

    break;

  case 27:

    {
        // MCOL-876. The change reuses existing infrastructure. 
        AtaRenameTable* renameAction = new AtaRenameTable((yyvsp[0].qualifiedName));
        AlterTableActionList* actionList = new AlterTableActionList();
        actionList->push_back(renameAction);
        (yyval.sqlStmt) = new AlterTableStatement((yyvsp[-2].qualifiedName), actionList);
    }

    break;

  case 28:

    {
		(yyval.tableElementList) = new TableElementList();
		(yyval.tableElementList)->push_back((yyvsp[0].schemaObject));
	}

    break;

  case 29:

    {
		(yyval.tableElementList) = (yyvsp[-2].tableElementList);
		(yyval.tableElementList)->push_back((yyvsp[0].schemaObject));
	}

    break;

  case 32:

    {
		(yyval.schemaObject) = (yyvsp[-1].schemaObject);
		(yyvsp[-1].schemaObject)->fName = (yyvsp[-2].str);
	}

    break;

  case 33:

    {
		(yyval.schemaObject) = (yyvsp[-1].schemaObject);
		(yyvsp[-1].schemaObject)->fName = (yyvsp[-2].str);
	}

    break;

  case 34:

    {(yyval.str) = (yyvsp[0].str);}

    break;

  case 35:

    {(yyval.str) = "noname";}

    break;

  case 38:

    {(yyval.schemaObject) = new TableCheckConstraintDef((yyvsp[0].str));}

    break;

  case 39:

    {
		if ((yyvsp[-3].constraintType) == DDL_UNIQUE)
		    (yyval.schemaObject) = new TableUniqueConstraintDef((yyvsp[-1].columnNameList));
        else if ((yyvsp[-3].constraintType) == DDL_PRIMARY_KEY)
            (yyval.schemaObject) = new TablePrimaryKeyConstraintDef((yyvsp[-1].columnNameList));
	}

    break;

  case 40:

    {
		(yyval.columnNameList) = new vector<string>;
		(yyval.columnNameList)->push_back((yyvsp[0].str));
	}

    break;

  case 41:

    {
		(yyval.columnNameList) = (yyvsp[-2].columnNameList);
		(yyval.columnNameList)->push_back((yyvsp[0].str));
	}

    break;

  case 42:

    {(yyval.constraintType) = DDL_PRIMARY_KEY;}

    break;

  case 43:

    {(yyval.constraintType) = DDL_UNIQUE;}

    break;

  case 44:

    {
		(yyval.schemaObject) = new TableReferencesConstraintDef((yyvsp[-8].columnNameList), (yyvsp[-5].qualifiedName), (yyvsp[-3].columnNameList), (yyvsp[-1].matchType), (yyvsp[0].refAction));
	}

    break;

  case 46:

    {(yyval.matchType) = DDL_FULL;}

    break;

  case 47:

    {(yyval.matchType) = (yyvsp[0].matchType);}

    break;

  case 48:

    {(yyval.matchType) = DDL_FULL;}

    break;

  case 49:

    {(yyval.matchType) = DDL_PARTIAL;}

    break;

  case 51:

    {(yyval.refAction) = NULL;}

    break;

  case 52:

    {
		(yyval.refAction) = new ReferentialAction();
		(yyval.refAction)->fOnUpdate = (yyvsp[-1].refActionCode);
		(yyval.refAction)->fOnDelete = (yyvsp[0].refActionCode);
	}

    break;

  case 53:

    {
		(yyval.refAction) = new ReferentialAction();
		(yyval.refAction)->fOnUpdate = (yyvsp[0].refActionCode);
		(yyval.refAction)->fOnDelete = (yyvsp[-1].refActionCode);
	}

    break;

  case 55:

    {(yyval.refActionCode) = DDL_NO_ACTION;}

    break;

  case 57:

    {(yyval.refActionCode) = DDL_NO_ACTION;}

    break;

  case 58:

    {(yyval.refActionCode) = (yyvsp[0].refActionCode);}

    break;

  case 59:

    {(yyval.refActionCode) = (yyvsp[0].refActionCode);}

    break;

  case 60:

    {(yyval.refActionCode) = DDL_CASCADE;}

    break;

  case 61:

    {(yyval.refActionCode) = DDL_SET_NULL;}

    break;

  case 62:

    {(yyval.refActionCode) = DDL_SET_DEFAULT;}

    break;

  case 63:

    {(yyval.refActionCode) = DDL_NO_ACTION;}

    break;

  case 64:

    {(yyval.refActionCode) = DDL_RESTRICT;}

    break;

  case 65:

    {
		(yyval.tableOptionMap) = new TableOptionMap();
		(*(yyval.tableOptionMap))[(yyvsp[0].tableOption)->first] = (yyvsp[0].tableOption)->second;
		delete (yyvsp[0].tableOption);
	}

    break;

  case 66:

    {
		(yyval.tableOptionMap) = (yyvsp[-1].tableOptionMap);
		(*(yyval.tableOptionMap))[(yyvsp[0].tableOption)->first] = (yyvsp[0].tableOption)->second;
		delete (yyvsp[0].tableOption);
	}

    break;

  case 67:

    {}

    break;

  case 68:

    {}

    break;

  case 69:

    {(yyval.tableOption) = new pair<string,string>("engine", (yyvsp[0].str));}

    break;

  case 70:

    {(yyval.tableOption) = new pair<string,string>("max_rows", (yyvsp[0].str));}

    break;

  case 71:

    {(yyval.tableOption) = new pair<string,string>("min_rows", (yyvsp[0].str));}

    break;

  case 72:

    {(yyval.tableOption) = new pair<string,string>("comment", (yyvsp[0].str));}

    break;

  case 73:

    {(yyval.tableOption) = new pair<string,string>("comment", (yyvsp[0].str));}

    break;

  case 74:

    {
       (yyval.tableOption) = new pair<string,string>("auto_increment", (yyvsp[0].str));
    }

    break;

  case 75:

    {(yyval.tableOption) = new pair<string,string>("default charset", (yyvsp[0].str));}

    break;

  case 76:

    {(yyval.tableOption) = new pair<string, string>("default charset", (yyvsp[0].str));}

    break;

  case 77:

    {(yyval.tableOption) = new pair<string,string>("default charset", (yyvsp[0].str));}

    break;

  case 78:

    {(yyval.tableOption) = new pair<string, string>("default collate", (yyvsp[0].str));}

    break;

  case 79:

    {(yyval.tableOption) = new pair<string, string>("default collate", (yyvsp[0].str));}

    break;

  case 80:

    {
		(yyval.sqlStmt) = new AlterTableStatement((yyvsp[-1].qualifiedName), (yyvsp[0].ataList));
	}

    break;

  case 81:

    {
		if ((yyvsp[0].ata) != NULL) {
			(yyval.ataList) = new AlterTableActionList();
			(yyval.ataList)->push_back((yyvsp[0].ata));
		}
		else {
			/* An alter_table_statement requires at least one action.
			   So, this shouldn't happen. */
			(yyval.ataList) = NULL;
		}		
	}

    break;

  case 82:

    {
		(yyval.ataList) = (yyvsp[-2].ataList);
		(yyval.ataList)->push_back((yyvsp[0].ata));
	}

    break;

  case 83:

    {
		(yyval.ataList) = (yyvsp[-1].ataList);
		(yyval.ataList)->push_back((yyvsp[0].ata));
	}

    break;

  case 93:

    {(yyval.ata) = new AtaTableComment((yyvsp[0].str));}

    break;

  case 94:

    {(yyval.ata) = new AtaTableComment((yyvsp[0].str));}

    break;

  case 95:

    {(yyval.ata) = new AtaModifyColumnType((yyvsp[-1].str),(yyvsp[0].columnType));}

    break;

  case 96:

    {(yyval.ata) = new AtaModifyColumnType((yyvsp[-1].str),(yyvsp[0].columnType));}

    break;

  case 97:

    {(yyval.ata) = new AtaRenameColumn((yyvsp[-2].str), (yyvsp[-1].str), (yyvsp[0].columnType), NULL);}

    break;

  case 98:

    {(yyval.ata) = new AtaRenameColumn((yyvsp[-3].str), (yyvsp[-2].str), (yyvsp[-1].columnType), (yyvsp[0].columnOption));}

    break;

  case 99:

    {(yyval.ata) = new AtaRenameColumn((yyvsp[-2].str), (yyvsp[-1].str), (yyvsp[0].columnType), NULL);}

    break;

  case 100:

    {(yyval.ata) = new AtaRenameColumn((yyvsp[-3].str), (yyvsp[-2].str), (yyvsp[-1].columnType), (yyvsp[0].columnOption));}

    break;

  case 101:

    {(yyval.ata) = new AtaRenameColumn((yyvsp[-3].str), (yyvsp[-2].str), (yyvsp[-1].columnType), (yyvsp[0].constraintList), NULL);}

    break;

  case 102:

    {(yyval.ata) = new AtaRenameColumn((yyvsp[-3].str), (yyvsp[-2].str), (yyvsp[-1].columnType), (yyvsp[0].constraintList), NULL);}

    break;

  case 103:

    {(yyval.ata) = new AtaRenameColumn((yyvsp[-4].str), (yyvsp[-3].str), (yyvsp[-2].columnType), (yyvsp[-1].constraintList), NULL, (yyvsp[0].columnOption));}

    break;

  case 104:

    {(yyval.ata) = new AtaRenameColumn((yyvsp[-4].str), (yyvsp[-3].str), (yyvsp[-2].columnType), (yyvsp[-1].constraintList), NULL, (yyvsp[0].columnOption));}

    break;

  case 105:

    {(yyval.ata) = new AtaRenameColumn((yyvsp[-3].str), (yyvsp[-2].str), (yyvsp[-1].columnType), NULL, (yyvsp[0].colDefault));}

    break;

  case 106:

    {(yyval.ata) = new AtaRenameColumn((yyvsp[-3].str), (yyvsp[-2].str), (yyvsp[-1].columnType), NULL, (yyvsp[0].colDefault));}

    break;

  case 107:

    {(yyval.ata) = new AtaRenameColumn((yyvsp[-4].str), (yyvsp[-3].str), (yyvsp[-2].columnType), NULL, (yyvsp[-1].colDefault), (yyvsp[0].columnOption));}

    break;

  case 108:

    {(yyval.ata) = new AtaRenameColumn((yyvsp[-4].str), (yyvsp[-3].str), (yyvsp[-2].columnType), NULL, (yyvsp[-1].colDefault), (yyvsp[0].columnOption));}

    break;

  case 109:

    {(yyval.ata) = new AtaRenameColumn((yyvsp[-4].str), (yyvsp[-3].str), (yyvsp[-2].columnType), (yyvsp[-1].constraintList), (yyvsp[0].colDefault));}

    break;

  case 110:

    {(yyval.ata) = new AtaRenameColumn((yyvsp[-4].str), (yyvsp[-3].str), (yyvsp[-2].columnType), (yyvsp[-1].constraintList), (yyvsp[0].colDefault));}

    break;

  case 111:

    {(yyval.ata) = new AtaRenameColumn((yyvsp[-4].str), (yyvsp[-3].str), (yyvsp[-2].columnType), (yyvsp[0].constraintList), (yyvsp[-1].colDefault));}

    break;

  case 112:

    {(yyval.ata) = new AtaRenameColumn((yyvsp[-4].str), (yyvsp[-3].str), (yyvsp[-2].columnType), (yyvsp[0].constraintList), (yyvsp[-1].colDefault));}

    break;

  case 113:

    {(yyval.ata) = new AtaRenameColumn((yyvsp[-5].str), (yyvsp[-4].str), (yyvsp[-3].columnType), (yyvsp[-2].constraintList), (yyvsp[-1].colDefault), (yyvsp[0].columnOption));}

    break;

  case 114:

    {(yyval.ata) = new AtaRenameColumn((yyvsp[-5].str), (yyvsp[-4].str), (yyvsp[-3].columnType), (yyvsp[-2].constraintList), (yyvsp[-1].colDefault), (yyvsp[0].columnOption));}

    break;

  case 115:

    {(yyval.ata) = new AtaRenameColumn((yyvsp[-5].str), (yyvsp[-4].str), (yyvsp[-3].columnType), (yyvsp[-1].constraintList), (yyvsp[-2].colDefault), (yyvsp[0].columnOption));}

    break;

  case 116:

    {(yyval.ata) = new AtaRenameColumn((yyvsp[-5].str), (yyvsp[-4].str), (yyvsp[-3].columnType), (yyvsp[-1].constraintList), (yyvsp[-2].colDefault), (yyvsp[0].columnOption));}

    break;

  case 117:

    {
		(yyval.ata) = new AtaDropTableConstraint((yyvsp[-1].str), (yyvsp[0].refActionCode));
	}

    break;

  case 118:

    {(yyval.ata) = new AtaAddTableConstraint(dynamic_cast<TableConstraintDef *>((yyvsp[0].schemaObject)));}

    break;

  case 119:

    {(yyval.ata) = new AtaRenameTable((yyvsp[0].qualifiedName));}

    break;

  case 120:

    {(yyval.ata) = new AtaRenameTable((yyvsp[0].qualifiedName));}

    break;

  case 122:

    {
				if (x->fDBSchema.size())
					(yyval.qualifiedName) = new QualifiedName((char*)x->fDBSchema.c_str(), (yyvsp[0].str));
				else
				    (yyval.qualifiedName) = new QualifiedName((yyvsp[0].str));   
			}

    break;

  case 123:

    {
            (yyval.qualifiedName) = new QualifiedName((yyvsp[-2].str), (yyvsp[0].str));
        }

    break;

  case 126:

    { fix_column_length((yyvsp[0].schemaObject), x->default_table_charset); (yyval.ata) = new AtaAddColumn(dynamic_cast<ColumnDef*>((yyvsp[0].schemaObject)));}

    break;

  case 127:

    { fix_column_length((yyvsp[0].schemaObject), x->default_table_charset); (yyval.ata) = new AtaAddColumn(dynamic_cast<ColumnDef*>((yyvsp[0].schemaObject)));}

    break;

  case 128:

    {
        for (auto* elem : *(yyvsp[-1].tableElementList)) {
            fix_column_length(elem, x->default_table_charset);
        }
        (yyval.ata) = new AtaAddColumns((yyvsp[-1].tableElementList));
    }

    break;

  case 129:

    {
        for (auto* elem : *(yyvsp[-1].tableElementList)) {
            fix_column_length(elem, x->default_table_charset);
        }
        (yyval.ata) = new AtaAddColumns((yyvsp[-1].tableElementList));
    }

    break;

  case 134:

    {(yyval.columnOption) = (yyvsp[0].str);}

    break;

  case 135:

    {
		(yyval.schemaObject) = new ColumnDef((yyvsp[-2].str), (yyvsp[-1].columnType), NULL, NULL );
	}

    break;

  case 136:

    {
		(yyval.schemaObject) = new ColumnDef((yyvsp[-3].str), (yyvsp[-2].columnType), (yyvsp[0].constraintList), NULL);
	}

    break;

  case 137:

    {
		(yyval.schemaObject) = new ColumnDef((yyvsp[-4].str), (yyvsp[-3].columnType), (yyvsp[0].constraintList), (yyvsp[-1].colDefault));
	}

    break;

  case 138:

    {
		(yyval.schemaObject) = new ColumnDef((yyvsp[-3].str), (yyvsp[-2].columnType), NULL, (yyvsp[0].colDefault), NULL);
	}

    break;

  case 139:

    {
		(yyval.schemaObject) = new ColumnDef((yyvsp[-3].str), (yyvsp[-2].columnType), NULL, NULL, (yyvsp[0].columnOption) );
	}

    break;

  case 140:

    {
		(yyval.schemaObject) = new ColumnDef((yyvsp[-4].str), (yyvsp[-3].columnType), (yyvsp[-1].constraintList), NULL, (yyvsp[0].columnOption));
	}

    break;

  case 141:

    {
		(yyval.schemaObject) = new ColumnDef((yyvsp[-5].str), (yyvsp[-4].columnType), (yyvsp[-1].constraintList), (yyvsp[-2].colDefault), (yyvsp[0].columnOption));
	}

    break;

  case 142:

    {
		(yyval.schemaObject) = new ColumnDef((yyvsp[-4].str), (yyvsp[-3].columnType), (yyvsp[-1].constraintList), (yyvsp[0].colDefault));
	}

    break;

  case 143:

    {
		(yyval.schemaObject) = new ColumnDef((yyvsp[-5].str), (yyvsp[-4].columnType), (yyvsp[-2].constraintList), (yyvsp[-1].colDefault), (yyvsp[0].columnOption));
	}

    break;

  case 144:

    {
		(yyval.schemaObject) = new ColumnDef((yyvsp[-4].str), (yyvsp[-3].columnType), NULL, (yyvsp[-1].colDefault), (yyvsp[0].columnOption));
	}

    break;

  case 147:

    {
		(yyval.colDefault) = new ColumnDefaultValue((yyvsp[0].str));
	}

    break;

  case 148:

    {
		(yyval.colDefault) = new ColumnDefaultValue((yyvsp[0].str));
	}

    break;

  case 149:

    {(yyval.colDefault) = new ColumnDefaultValue(NULL);}

    break;

  case 150:

    {(yyval.colDefault) = new ColumnDefaultValue("$USER");}

    break;

  case 151:

    {(yyval.colDefault) = new ColumnDefaultValue("$CURRENT_USER");}

    break;

  case 152:

    {(yyval.colDefault) = new ColumnDefaultValue("$SESSION_USER");}

    break;

  case 153:

    {(yyval.colDefault) = new ColumnDefaultValue("$SYSTEM_USER");}

    break;

  case 154:

    {}

    break;

  case 155:

    {}

    break;

  case 156:

    { (yyval.str) = NULL; }

    break;

  case 157:

    { (yyval.str) = (yyvsp[0].str); }

    break;

  case 158:

    {}

    break;

  case 159:

    {}

    break;

  case 160:

    {
        (yyvsp[-2].columnType)->fCharset = (yyvsp[-1].str);
        (yyval.columnType) = (yyvsp[-2].columnType);
    }

    break;

  case 165:

    {
        (yyvsp[-2].columnType)->fCharset = (yyvsp[-1].str);
        (yyval.columnType) = (yyvsp[-2].columnType);
    }

    break;

  case 166:

    {
		(yyval.columnType) = new ColumnType(DDL_BLOB);
		(yyval.columnType)->fLength = DDLDatatypeLength[DDL_BLOB];
	}

    break;

  case 167:

    {
		(yyval.columnType) = new ColumnType(DDL_CLOB);
		(yyval.columnType)->fLength = DDLDatatypeLength[DDL_CLOB];
	}

    break;

  case 168:

    {
		(yyval.constraintList) = new ColumnConstraintList();
		(yyval.constraintList)->push_back((yyvsp[0].columnConstraintDef));
	}

    break;

  case 169:

    {
		(yyval.constraintList) = (yyvsp[-1].constraintList);
		(yyval.constraintList)->push_back((yyvsp[0].columnConstraintDef));
	}

    break;

  case 170:

    {
		(yyval.columnConstraintDef) = (yyvsp[-1].columnConstraintDef);

		if((yyvsp[0].constraintAttributes) != NULL)
		{
			(yyvsp[-1].columnConstraintDef)->fDeferrable = (yyvsp[0].constraintAttributes)->fDeferrable;
			(yyvsp[-1].columnConstraintDef)->fCheckTime = (yyvsp[0].constraintAttributes)->fCheckTime;
		}

	}

    break;

  case 171:

    {
		(yyval.columnConstraintDef) = (yyvsp[-1].columnConstraintDef);
		(yyvsp[-1].columnConstraintDef)->fName = (yyvsp[-2].str);

		if((yyvsp[0].constraintAttributes) != NULL)
		{
			(yyvsp[-1].columnConstraintDef)->fDeferrable = (yyvsp[0].constraintAttributes)->fDeferrable;
			(yyvsp[-1].columnConstraintDef)->fCheckTime = (yyvsp[0].constraintAttributes)->fCheckTime;
		}
		
	}

    break;

  case 172:

    {(yyval.constraintAttributes) = (yyvsp[0].constraintAttributes);}

    break;

  case 173:

    {(yyval.constraintAttributes) = NULL;}

    break;

  case 174:

    {
		(yyval.constraintAttributes) = new ConstraintAttributes((yyvsp[-1].cattr), ((yyvsp[0].cattr) != 0));
	}

    break;

  case 175:

    {
		(yyval.constraintAttributes) = new ConstraintAttributes((yyvsp[0].cattr), true);
	}

    break;

  case 177:

    {(yyval.cattr) = DDL_NON_DEFERRABLE;}

    break;

  case 178:

    {(yyval.cattr) = DDL_DEFERRABLE;}

    break;

  case 179:

    {(yyval.cattr) = DDL_INITIALLY_DEFERRED;}

    break;

  case 180:

    {(yyval.cattr) = DDL_INITIALLY_IMMEDIATE;}

    break;

  case 181:

    {(yyval.columnConstraintDef) = new ColumnConstraintDef(DDL_NOT_NULL);}

    break;

  case 182:

    {(yyval.columnConstraintDef) = new ColumnConstraintDef(DDL_UNIQUE);}

    break;

  case 183:

    {(yyval.columnConstraintDef) = new ColumnConstraintDef(DDL_PRIMARY_KEY);}

    break;

  case 184:

    {(yyval.columnConstraintDef) = new ColumnConstraintDef(DDL_AUTO_INCREMENT);}

    break;

  case 185:

    {(yyval.columnConstraintDef) = new ColumnConstraintDef((yyvsp[0].str));}

    break;

  case 186:

    {(yyval.str) = (yyvsp[-1].str);}

    break;

  case 187:

    {(yyval.str) = (yyvsp[-1].str);}

    break;

  case 190:

    {
		(yyval.columnType) = new ColumnType(DDL_CHAR);
		(yyval.columnType)->fLength = 1;
	}

    break;

  case 191:

    {
		(yyval.columnType) = new ColumnType(DDL_CHAR);
		(yyval.columnType)->fLength = 1;
	}

    break;

  case 192:

    {
		(yyval.columnType) = new ColumnType(DDL_CHAR);
		(yyval.columnType)->fLength = atoi((yyvsp[-1].str));
	}

    break;

  case 193:

    {
		(yyval.columnType) = new ColumnType(DDL_CHAR);
		(yyval.columnType)->fLength = atoi((yyvsp[-1].str));
	}

    break;

  case 194:

    {
		(yyval.columnType) = new ColumnType(DDL_VARCHAR);
		(yyval.columnType)->fLength = atoi((yyvsp[-1].str));
	}

    break;

  case 195:

    {
		(yyval.columnType) = new ColumnType(DDL_VARCHAR);
		(yyval.columnType)->fLength = atoi((yyvsp[-1].str));
	}

    break;

  case 196:

    {
		(yyval.columnType) = new ColumnType(DDL_VARCHAR);
		(yyval.columnType)->fLength = atoi((yyvsp[-1].str));
	}

    break;

  case 197:

    {
		(yyval.columnType) = new ColumnType(DDL_VARBINARY);
		(yyval.columnType)->fLength = atoi((yyvsp[-1].str));
	}

    break;

  case 198:

    {
		(yyval.columnType) = new ColumnType(DDL_BLOB);
		(yyval.columnType)->fLength = atol((yyvsp[-1].str));
	}

    break;

  case 199:

    {
		(yyval.columnType) = new ColumnType(DDL_BLOB);
		(yyval.columnType)->fLength = 65535;
	}

    break;

  case 200:

    {
		(yyval.columnType) = new ColumnType(DDL_BLOB);
		(yyval.columnType)->fLength = 255;
	}

    break;

  case 201:

    {
		(yyval.columnType) = new ColumnType(DDL_BLOB);
		(yyval.columnType)->fLength = 16777215;
	}

    break;

  case 202:

    {
		(yyval.columnType) = new ColumnType(DDL_BLOB);
		(yyval.columnType)->fLength = 2100000000;
	}

    break;

  case 203:

    {
		(yyval.columnType) = new ColumnType(DDL_TEXT);
		(yyval.columnType)->fLength = atol((yyvsp[-1].str));
		(yyval.columnType)->fExplicitLength = true;
	}

    break;

  case 204:

    {
		(yyval.columnType) = new ColumnType(DDL_TEXT);
		(yyval.columnType)->fLength = 65535;
	}

    break;

  case 205:

    {
		(yyval.columnType) = new ColumnType(DDL_TEXT);
		(yyval.columnType)->fLength = 255;
	}

    break;

  case 206:

    {
		(yyval.columnType) = new ColumnType(DDL_TEXT);
		(yyval.columnType)->fLength = 16777215;
	}

    break;

  case 207:

    {
		(yyval.columnType) = new ColumnType(DDL_TEXT);
		(yyval.columnType)->fLength = 2100000000;
	}

    break;

  case 210:

    {
		(yyvsp[0].columnType)->fType = DDL_NUMERIC;
		(yyvsp[0].columnType)->fLength = DDLDatatypeLength[DDL_NUMERIC];
		(yyval.columnType) = (yyvsp[0].columnType);
	}

    break;

  case 211:

    {
		(yyvsp[-1].columnType)->fType = DDL_UNSIGNED_NUMERIC;
		(yyvsp[-1].columnType)->fLength = DDLDatatypeLength[DDL_UNSIGNED_NUMERIC];
		(yyval.columnType) = (yyvsp[-1].columnType);
	}

    break;

  case 212:

    {
		(yyvsp[0].columnType)->fType = DDL_DECIMAL;
/*	   	$2->fLength = DDLDatatypeLength[DDL_DECIMAL]; */
		(yyval.columnType) = (yyvsp[0].columnType);
	}

    break;

  case 213:

    {
		(yyvsp[-1].columnType)->fType = DDL_UNSIGNED_DECIMAL;
/*	   	$3->fLength = DDLDatatypeLength[DDL_DECIMAL]; */
		(yyval.columnType) = (yyvsp[-1].columnType);
	}

    break;

  case 214:

    {
		(yyvsp[0].columnType)->fType = DDL_DECIMAL;
		(yyvsp[0].columnType)->fLength = DDLDatatypeLength[DDL_DECIMAL];
		(yyval.columnType) = (yyvsp[0].columnType);
	}

    break;

  case 215:

    {
		(yyvsp[-1].columnType)->fType = DDL_UNSIGNED_DECIMAL;
		(yyvsp[-1].columnType)->fLength = DDLDatatypeLength[DDL_UNSIGNED_DECIMAL];
		(yyval.columnType) = (yyvsp[-1].columnType);
	}

    break;

  case 216:

    {
		(yyval.columnType) = new ColumnType(DDL_INT);
		(yyval.columnType)->fLength = DDLDatatypeLength[DDL_INT];
	}

    break;

  case 217:

    {
		(yyval.columnType) = new ColumnType(DDL_INT);
		(yyval.columnType)->fLength = DDLDatatypeLength[DDL_INT];
	}

    break;

  case 218:

    {
		(yyval.columnType) = new ColumnType(DDL_SMALLINT);
		(yyval.columnType)->fLength = DDLDatatypeLength[DDL_SMALLINT];
	}

    break;

  case 219:

    {
		(yyval.columnType) = new ColumnType(DDL_TINYINT);
		(yyval.columnType)->fLength = DDLDatatypeLength[DDL_TINYINT];
	}

    break;

  case 220:

    {
		(yyval.columnType) = new ColumnType(DDL_BIGINT);
		(yyval.columnType)->fLength = DDLDatatypeLength[DDL_BIGINT];
	}

    break;

  case 221:

    {
		(yyval.columnType) = new ColumnType(DDL_UNSIGNED_INT);
		(yyval.columnType)->fLength = DDLDatatypeLength[DDL_INT];
	}

    break;

  case 222:

    {
		(yyval.columnType) = new ColumnType(DDL_UNSIGNED_INT);
		(yyval.columnType)->fLength = DDLDatatypeLength[DDL_INT];
	}

    break;

  case 223:

    {
		(yyval.columnType) = new ColumnType(DDL_UNSIGNED_SMALLINT);
		(yyval.columnType)->fLength = DDLDatatypeLength[DDL_SMALLINT];
	}

    break;

  case 224:

    {
		(yyval.columnType) = new ColumnType(DDL_UNSIGNED_TINYINT);
		(yyval.columnType)->fLength = DDLDatatypeLength[DDL_TINYINT];
	}

    break;

  case 225:

    {
		(yyval.columnType) = new ColumnType(DDL_UNSIGNED_BIGINT);
		(yyval.columnType)->fLength = DDLDatatypeLength[DDL_BIGINT];
	}

    break;

  case 226:

    {
                (yyval.columnType) = new ColumnType(DDL_TINYINT);
                (yyval.columnType)->fLength = DDLDatatypeLength[DDL_TINYINT];
                (yyval.columnType)->fPrecision = 1;
        }

    break;

  case 227:

    {
                (yyval.columnType) = new ColumnType(DDL_TINYINT);
                (yyval.columnType)->fLength = DDLDatatypeLength[DDL_TINYINT];
                (yyval.columnType)->fPrecision = 1;
        }

    break;

  case 228:

    {
		(yyval.columnType) = new ColumnType(DDL_MEDINT);
		(yyval.columnType)->fLength = DDLDatatypeLength[DDL_MEDINT];
	}

    break;

  case 229:

    {
		(yyval.columnType) = new ColumnType(DDL_UNSIGNED_MEDINT);
		(yyval.columnType)->fLength = DDLDatatypeLength[DDL_UNSIGNED_MEDINT];
	}

    break;

  case 230:

    {(yyval.columnType) = new ColumnType(atoi((yyvsp[-1].str)), 0);}

    break;

  case 231:

    {(yyval.columnType) = new ColumnType(atoi((yyvsp[-3].str)), atoi((yyvsp[-1].str)));}

    break;

  case 232:

    {(yyval.columnType) = new ColumnType(10,0);}

    break;

  case 233:

    {(yyval.str) = NULL;}

    break;

  case 234:

    {(yyval.str) = NULL;}

    break;

  case 235:

    {
		(yyval.columnType) = new ColumnType(DDL_DOUBLE);
		(yyval.columnType)->fLength = DDLDatatypeLength[DDL_DOUBLE];
	}

    break;

  case 236:

    {
		(yyval.columnType) = new ColumnType(DDL_UNSIGNED_DOUBLE);
		(yyval.columnType)->fLength = DDLDatatypeLength[DDL_DOUBLE];
	}

    break;

  case 237:

    {
		(yyval.columnType) = new ColumnType(DDL_DOUBLE);
		(yyval.columnType)->fLength = DDLDatatypeLength[DDL_DOUBLE];
	}

    break;

  case 238:

    {
		(yyval.columnType) = new ColumnType(DDL_UNSIGNED_DOUBLE);
		(yyval.columnType)->fLength = DDLDatatypeLength[DDL_DOUBLE];
	}

    break;

  case 239:

    {
		(yyval.columnType) = new ColumnType(DDL_DOUBLE);
		(yyval.columnType)->fLength = DDLDatatypeLength[DDL_DOUBLE];
	}

    break;

  case 240:

    {
		(yyval.columnType) = new ColumnType(DDL_UNSIGNED_DOUBLE);
		(yyval.columnType)->fLength = DDLDatatypeLength[DDL_DOUBLE];
	}

    break;

  case 241:

    {
		(yyval.columnType) = new ColumnType(DDL_FLOAT);
		(yyval.columnType)->fLength = DDLDatatypeLength[DDL_FLOAT];
	}

    break;

  case 242:

    {
		(yyval.columnType) = new ColumnType(DDL_UNSIGNED_FLOAT);
		(yyval.columnType)->fLength = DDLDatatypeLength[DDL_FLOAT];
	}

    break;

  case 243:

    {(yyval.str) = NULL;}

    break;

  case 244:

    {(yyval.str) = NULL;}

    break;

  case 245:

    {(yyval.str) = NULL;}

    break;

  case 249:

    {
		(yyval.columnType) = new ColumnType(DDL_DATETIME);
		(yyval.columnType)->fLength = DDLDatatypeLength[DDL_DATETIME];
                (yyval.columnType)->fPrecision = (yyvsp[0].ival);
	}

    break;

  case 250:

    {
		(yyval.columnType) = new ColumnType(DDL_DATE);
		(yyval.columnType)->fLength = DDLDatatypeLength[DDL_DATE];
	}

    break;

  case 251:

    {
		(yyval.columnType) = new ColumnType(DDL_TIME);
		(yyval.columnType)->fLength = DDLDatatypeLength[DDL_TIME];
		(yyval.columnType)->fPrecision = (yyvsp[0].ival);
	}

    break;

  case 252:

    {
		(yyval.columnType) = new ColumnType(DDL_TIMESTAMP);
		(yyval.columnType)->fLength = DDLDatatypeLength[DDL_TIMESTAMP];
		(yyval.columnType)->fPrecision = (yyvsp[0].ival);
	}

    break;

  case 253:

    {(yyval.ival) = atoi((yyvsp[-1].str));}

    break;

  case 254:

    {(yyval.ival) = -1;}

    break;

  case 255:

    {(yyval.ata) = new AtaDropColumn((yyvsp[-1].str), (yyvsp[0].refActionCode));}

    break;

  case 256:

    {(yyval.ata) = new AtaDropColumn((yyvsp[-1].str), (yyvsp[0].refActionCode));}

    break;

  case 257:

    {(yyval.ata) = new AtaDropColumns((yyvsp[-1].columnNameList));}

    break;

  case 258:

    {(yyval.ata) = new AtaDropColumns((yyvsp[-1].columnNameList));}

    break;

  case 259:

    {(yyval.ata) = new AtaDropColumns((yyvsp[-1].columnNameList));}

    break;

  case 260:

    {(yyval.refActionCode) = DDL_CASCADE;}

    break;

  case 261:

    {(yyval.refActionCode) = DDL_RESTRICT;}

    break;

  case 262:

    {(yyval.refActionCode) = DDL_NO_ACTION;}

    break;

  case 263:

    {(yyval.ata) = new AtaSetColumnDefault((yyvsp[-2].str), (yyvsp[0].colDefault));}

    break;

  case 264:

    {(yyval.ata) = new AtaDropColumnDefault((yyvsp[-2].str));}

    break;



      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (x, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (x, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, x);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, x);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (x, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, x);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, x);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}




